#!/bin/bash
#2007 Lesser GPL licence v2 (http://www.fsf.org/licensing/licenses/lgpl.html)
#generates index.html master help page. called from petget, rc.update, createpuppy.
#if no passed param, regenerate entire index.html.
# $1=insert|remove optional first param (without, default is insert).
# rest of passed params is a specification for finding the help files:
#  inserting: $2 is path prefix of the expanded new package.
#  removing: $2 is path/filename of .files, list of installed files.

WKGDIR="`pwd`"

HLPPREFIX="";ADDMODE=""
if [ $1 ];then
 [ "$1" = "insert" ] && ADDMODE="insert"
 [ "$1" = "remove" ] && ADDMODE="remove"
 HLPPREFIX="$@"
 [ "$ADDMODE" = "insert" ] && HLPPREFIX="`echo -n "$@" | sed -e 's/^insert //g'`"
 [ "$ADDMODE" = "remove" ] && HLPPREFIX="`echo -n "$@" | sed -e 's/^remove //g'`"
 [ "$ADDMODE" = "" ] && ADDMODE="insert" #default.
 #extract all the current links...
 grep '<li><a href="/usr/share/doc' /usr/share/doc/index.html > /tmp/index-middle-old
fi

if [ "$HLPPREFIX" = "" ];then
 #regenerate everything...
 HLPPGS="`find /usr/share/doc -maxdepth 5 -name \*.htm -o -name \*.html -o -name \*.txt | tr '\n' ' '`"
 SYMLNKS="`find /usr/share/doc -maxdepth 1 -type l | tr "\n" " "`"
 for ONELNK in $SYMLNKS
 do
  if [ -d $ONELNK ];then
   ONEHLP="`find $ONELNK -maxdepth 5 -name \*.htm -o -name \*.html -o -name \*.txt | tr '\n' ' '`"
   HLPPGS="${HLPPGS} ${ONEHLP}"
  fi
 done
else
 if [ "$ADDMODE" = "insert" ];then
  cd $HELPPREFIX
  HLPPGS="`find ./usr/share/doc -maxdepth 5 -name \*.htm -o -name \*.html -o -name \*.txt | sed -e 's/^\.//g' | tr '\n' ' '`"
  SYMLNKS="`find ./usr/share/doc -maxdepth 1 -type l | tr "\n" " "`"
  for ONELNK in $SYMLNKS
  do
   if [ -d $ONELNK ];then
    ONEHLP="`find $ONELNK -maxdepth 5 -name \*.htm -o -name \*.html -o -name \*.txt | sed -e 's/^\.//g' | tr '\n' ' '`"
    HLPPGS="${HLPPGS} ${ONEHLP}"
   fi
  done
  cd $WKGDIR
 else #remove
  HLPPKGS="`cat $HELPPREFIX | grep '^/usr/share/doc/' | tr '\n' ' '`"
 fi
fi

#generate top half...
cp -af /usr/share/doc/index-skeleton-top /usr/share/doc/index.html

#application help links...
echo -n "" > /tmp/index-middle
echo "Generating master help page /usr/share/doc/index.html..."
for ONEPG in $HLPPGS
do
 [ "$ONEPG" = "/usr/share/doc/index.html" ] && continue
 [ ! "`echo -n "$ONEPG" | grep --extended-regexp '/HOWTO|ANNOUNCE|CHANGES|README|LICENCE'`" = "" ] && continue
 echo "Processing $ONEPG" 
 ONEBASE="`basename $ONEPG`"
 ONENAME="`echo -n "$ONEBASE" | cut -f 1 -d '.'`"
 ONEDIR="`dirname $ONEPG`"
 
 #what about some short description?
 #search packages.txt and alienpackages.txt...
 APATTERN="^\"${ONENAME}\-"
 cp -f /root/.packages/packages.txt /tmp/allpackages.txt.tmp
 [ -f /root/.packages/alienpackages.txt ] && cat /root/.packages/alienpackages.txt >> /tmp/allpackages.txt.tmp
 MENUDESCR="`cat /tmp/allpackages.txt.tmp | grep -i "${APATTERN}" | head -n 1 | cut -f 4 -d '"' | cut -f 2 -d ':' | sed -e 's/^ //g'`" #'Geany
 rm -f /tmp/allpackages.txt.tmp
 #search .desktop files...
 APATTERN="^${ONENAME}[-.]"
 [ "$MENUDESCR" = "" ] && MENUDESCR="`ls -1 /usr/share/applications | grep -i "${APATTERN}" | head -n 1 | cut -f 2-9 -d '-' | cut -f 1 -d '.' | tr '-' ' '`"
 MENUNAME="`ls -1 /usr/share/applications | grep -i "${APATTERN}" | head -n 1 | cut -f 1 -d '-'`"
 [ ! "$MENUDESCR" = "" ] && MENUDESCR=", $MENUDESCR"
 [ ! "$MENYNAME" = "" ] && ONENAME="$MENUNAME"
 
 if [ "$ONENAME" = "index" ];then
  ONENAME="`basename $ONEDIR`"
 fi
 
 echo -e "<li><a href=\"${ONEPG}\">${ONENAME}</a>${MENUDESCR}</li>" >> /tmp/index-middle
done

[ "$ADDMODE" = "insert" ] && cat /tmp/index-middle-old >> /tmp/index-middle
if [ "$ADDMODE" = "remove" ];then
 #/tmp/index/middle has entries that are to be removed from /tmp/index-middle-old...
 diff /tmp/index-middle-old /tmp/index-middle | grep '^< ' | sed -e 's/^< //g' > /tmp/index-middle-new
 sync
 mv -f /tmp/index-middle-new /tmp/index-middle
fi
cat /tmp/index-middle | sort --field-separator='>' --key=2 --unique >> /usr/share/doc/index.html
sync

#generate bottom half...
cat /usr/share/doc/index-skeleton-bottom >> /usr/share/doc/index.html

###END###
